/*****************************************************************************
*File: 	        fits_hdr.h
*Programmers:	Anne Raugh
*               Dorian Winterfeld
*Institution:   PDS/Small Bodies Node
*               University of Maryland
*Date:	        March 28, 1995
*Last revision:
*Abstract:      Routines to  OUTPUT the FITS data structure to the
*               FITS HEADER FILE
*****************************************************************************/
#ifndef HDR_HDR
#define HDR_HDR

int write_FITS_header(FITS_object *main_object);
int write_keyword(FITS_keyword *key, FITS_object *object);
int format_value(FITS_keyword *key, FITS_object *object);
int format_string(FITS_keyword *key);
int format_date(FITS_keyword *key);
int format_time(FITS_keyword *key, char *fits_date, char *fits_time);
int format_real(FITS_keyword *key);
int format_integer(FITS_keyword *key);
int write_comment(FITS_keyword *key);
void append_blanks(void);


#endif
